/**
 * Allows for a function to be called for a certain amount of time
 */
class LimitedTimeCall(startWith: Int = 0) {
  def msTime = System.nanoTime / 1000000

  var endTime = msTime + startWith

  def runFor(milliseconds: Int) {
    endTime = msTime + milliseconds
  }

  def apply(f: => Unit) {
    if (msTime < endTime) f
  }
}