import java.awt.event.ActionEvent
import scala.swing._
//import scala.swing.Dialog
import java.io.File
import javax.swing.filechooser.FileFilter
import FileChooser.Result._
import scala.concurrent.ops

/**
 * Created by IntelliJ IDEA.
 * User: Sebastian Stabinger
 * Date: Aug 23, 2010
 * Time: 6:35:27 PM
 */

class ARSFileFilter extends FileFilter {
  def getDescription = "ARS Files"

  def accept(p1: File) = p1.getAbsolutePath.toLowerCase.endsWith(".ars") || p1.isDirectory
}

object SwingFileDialog {
  /**
   * Opens a Dialog to choose a File in a seperate thread.
   * If a file was chosen the function callback will be called
   * Otherwise nothing happens
   * @parameter defaultPath : Path in which the File Dialog opens
   * @parameter text : Text to be shown as the Title of the Dialog (in most cases Open or Save)
   * @parameter callback : A function that takes a String which is executed when the OK-Button is beeing pressed
   */
  def apply(defaultPath: String, text: String)(callback: String => Unit) {
    ops.spawn {
      val dir = new File(defaultPath)
      val chooser = new FileChooser(dir)
      chooser.fileFilter = new ARSFileFilter
      val result = chooser.showDialog(null, text)
      if (result == Approve) callback(chooser.selectedFile.toString)
    }
  }
}

object SParseDialog {
  import java.awt.event.ActionListener
  def apply(preset: String, title: String = "Parse Dialog")(callback: String => Unit) {
    ops.spawn {
      val dialog = new ParseDialog
      dialog.setTitle(title)
      dialog.textArea.setText(preset)
      dialog.textArea.setAutoscrolls(true)
      dialog.buttonOK.addActionListener(new ActionListener() {
        def actionPerformed(p1: ActionEvent) = callback(dialog.textArea.getText)
      })
      dialog.pack
      dialog.setVisible(true)
    }
  }
}