import ProcessingWrapper._
import processing.core.{PConstants => pC}

/**
 * Created by IntelliJ IDEA.
 * User: Sebastian Stabinger
 * Date: Sep 19, 2010
 * Time: 11:00:19 PM
 */

class TextInput(val prompt: String = "ParsePrompt: ", val pos: Point = Point(XSIZE / 2, YSIZE / 2))(val ret: String => Unit) {
  var input = ""
  var esc: (String => Unit) = {x => ()}
  var visible = false

  var textSize = 24
  var textColor = PARSE_PROMPT_TEXT_COLOR
  var backgroundColor = PARSE_PROMPT_COLOR

  def setEsc(f: (String => Unit)) {esc = f}

  def +=(c: Char) {
    c match {
      case pC.RETURN | pC.ENTER =>
        visible = false
        ret(input)
        input = ""
      case pC.ESC =>
        visible = false
        esc(input)
        input = ""
      case pC.BACKSPACE => input = if (input.size == 0) "" else input.init
      case pC.TAB => ()
      case pC.DELETE => ()
      case x => input = input + c
    }
  }

  def draw() {
    def drawBox() {
      p.fill(backgroundColor)
      p.stroke(backgroundColor)
      p.rect(0, pos.y - textSize, XSIZE, textSize * 2)
    }
    if (visible) {
      drawBox()
      p.textSize(textSize)
      p.fill(textColor)
      p.text(prompt + input, pos.x, pos.y)
      p.textSize(standardTextSize)
    }
  }
}